﻿using System;
using System.Collections.Generic;
using System.Text;

using Com.Piwigo.Lib.DTO;
using System.ComponentModel;
using System.Collections.ObjectModel;

namespace Com.Piwigo.Wpf.DTO
{

    public class PwgImageWPF : INotifyPropertyChanged
    {
        private String _imgSource;
        public String ImgSource
        {
            set { _imgSource = value; OnPropertyChanged("ImgSource"); }
            get
            {
                if (_imgSource == null)
                {
                    _imgSource = Com.Piwigo.Wpf.Service.ImageCacheManager.Instance.GetImageFilename(this);
                }
                return _imgSource;
            }
        }
        

        private Int32 _id;
        public  Int32 Id
        {
            set { _id = value; OnPropertyChanged("Id"); }
            get { return _id; }
        }

        private Int32 _width;
        public Int32 Width
        {
            set { _width = value; OnPropertyChanged("Width"); }
            get { return _width; }
        }

        private Int32 _height;
        public Int32 Height
        {
            set { _height = value; OnPropertyChanged("Height"); }
            get { return _height; }
        }

        private String _file;
        public  String File
        {
            set { _file = value; OnPropertyChanged("File"); }
            get { return _file; }
        }

        private Uri _urlThunb;
        public  Uri UrlThunb
        {
            set { _urlThunb = value; OnPropertyChanged("UrlThunb"); }
            get { return _urlThunb; }
        }

        private Uri _urlElement;
        public  Uri UrlElement
        {
            set { _urlElement = value; OnPropertyChanged("UrlElement"); }
            get { return _urlElement; }
        }

        private Uri _urlHighDef;
        public  Uri UrlHighDef
        {
            set { _urlHighDef = value; OnPropertyChanged("UrlHighDef"); }
            get { return _urlHighDef; }
        }

        private Int64 _counter;
        public Int64 Counter
        {
            set { _counter = value; OnPropertyChanged("Counter"); }
            get { return _counter; }
        }

        private ObservableCollection<PwgTag> _tags;
        public ObservableCollection<PwgTag> Tags
        {
            set { _tags = value; OnPropertyChanged("Tags"); }
            get { return _tags; }
        }

        //public List<PwgCategoryWPF> Categories { get; set; }
        private ObservableCollection<PwgCategoryWPF> _categories;
        public ObservableCollection<PwgCategoryWPF> Categories
        {
            set { _categories = value; OnPropertyChanged("Categories"); }
            get { return _categories; }
        }
        public event PropertyChangedEventHandler PropertyChanged;
        private void OnPropertyChanged(String info)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(info));
        }
    }

    public class PwgImageRate : INotifyPropertyChanged
    {
        private Int32 _count;
        public Int32 Count
        {
            set { _count = value; OnPropertyChanged("Count"); }
            get { return _count; }
        }

        private Double _average;
        public Double Average
        {
            set { _average = value; OnPropertyChanged("Average"); }
            get { return _average; }
        }

        private Double _stdev;
        public Double Stdev
        {
            set { _stdev = value; OnPropertyChanged("Stdev"); }
            get { return _stdev; }
        }


        public event PropertyChangedEventHandler PropertyChanged;
        private void OnPropertyChanged(String info)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(info));
        }
    }
}
